from labscript import *
from labscript_devices.SpinnakerCamera.labscript_devices import SpinnakerCamera



Flir_global_camera_attributes = {
    'AnalogControl::GainAuto': 'Off',
    'AnalogControl::Gain': 0.0,
    'AnalogControl::BlackLevelEnabled': True,
    'AnalogControl::GammaEnabled': False,
    'AnalogControl::SharpnessEnabled': False,
    'ImageFormatControl::OffsetX': 0,
    'ImageFormatControl::OffsetY': 0,
    'ImageFormatControl::Width': 1288,
    'ImageFormatControl::Height': 964,
    'ImageFormatControl::PixelFormat': 'Mono16',
    'ImageFormatControl::VideoMode': 'Mode1',
    'AcquisitionControl::TriggerMode': 'Off',
    'AcquisitionControl::TriggerSource': 'Line0',
    'AcquisitionControl::TriggerSelector': 'FrameStart',
    'AcquisitionControl::ExposureTime':0.001,
    'AcquisitionControl::TriggerActivation': 'RisingEdge',
    'AcquisitionControl::AutoExposureTimeLowerLimit': 10.,
    'AcquisitionControl::AcquisitionMode': 'Continuous',
    'GigEVision::GevSCPSPacketSize': 9000,
    'GigEVision::GevSCPD': 80000,
    }

CCT_manual_mode_attributes = {
    'AcquisitionControl::TriggerMode': 'Off',
    'AcquisitionControl::ExposureMode': 'Timed'
}
CCT_buffered_mode_attributes = {
    'AcquisitionControl::TriggerMode': 'On',
    'AcquisitionControl::ExposureMode': 'TriggerWidth',
}

SpinnakerCamera(name='Cam_fluorescence', parent_device=DO, connection='port1/line4',
                serial_number=20334664, trigger_edge_type='rising',
                camera_attributes={**Flir_global_camera_attributes,
                                   **CCT_buffered_mode_attributes},
                manual_mode_camera_attributes={**Flir_global_camera_attributes,
                                               **CCT_manual_mode_attributes})
											   
start()
t=0											   
Cam_fluorescence.expose(t, name='MOT fluo', frametype='atoms',trigger_duration=0.0005)
t+=1
stop(t)